CSECT   PRPCD
C       REVISED 4/25/73
cloli   declarations for common CNTRLS simplified
cloli   changes to avoid warnings in Sceptre written *.f
cloli       if(1.gt.2)print *,KWAY to avoid unused dummy warnings 
cloli       common WPRAM eliminated
cloli       declaration of commons /xmr/ and /MRG/ as in acprep.f 
      SUBROUTINE PRPCD
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
 
      include 'tapes.inc'

      COMMON /CNTRLS/  PMUJ(81),VECEQS
         DIMENSION     CTROLS(160)
         EQUIVALENCE  (CTROLS(1),PMUJ(1))
      COMMON /SCNTBL/  NBRANS,NLINKS,ISKIP(18),NCL(17)
      COMMON /OUTPUT/  OU,NOUTPS
      COMMON /BCD/     BCDNCL(21)
         CHARACTER*4   BCDNCL
      COMMON /BUFERS/  NBUFF,IBUFF,BUFFER(20)
         CHARACTER*4   BUFFER
      COMMON /WPRAM/   NDPW,LDPW,WNAME(50)
         CHARACTER*8   WNAME

      CHARACTER*8      TAPE(9)
      CHARACTER*4      BOUTPT,XIBCD
      CHARACTER*8      SECT
      CHARACTER*8      BLANK
      CHARACTER*8      MRI,MRGI
 
      DATA INT3 /3/,INT1 /1/
      DATA BLANK /' '/
      DATA SECT  /'CSECT'/
      DATA MRI   /'MRI'/
      DATA MRGI   /'MRGI'/
      CALL WTSPTP(SECT,'CDCALC',6,NERROR)
      CALL WTSPTP(BLANK,'SUBROUTINE CDCALC(OMEGA,KWAY)',29,NERR)
      CALL WTSPTP(BLANK,'IMPLICIT REAL * 8(A,C,D,F-H,L,M,O,P,R-U,Y),'//
     * 'INTEGER * 2 (B), COMPLEX * 16(E,I,J,Q,V-X,Z)',87,NERR)
      CALL WTSPTP(BLANK,'COMPLEX * 16 FPZ,FCZ,FRZ,OUTBFR',31,NERR)
      CALL BANDM
 
C     GENERATE COMPLEX DEFINED PARAMETER COMMON
 
      IF(NDPW .EQ. 0) GO TO 20
   20 KST=1
      CALL CPY('COMMON/OUTDTA/OUTBFR(   )',INT1,BUFFER,KST,25)
      KST=KST-4
      KOUTPS=NOUTPS+1
      BOUTPT= XIBCD(KOUTPS,INT3,INT1,NERR)
      CALL CPY(BOUTPT,INT1,BUFFER,KST,INT3)
      CALL WTSPTP (BLANK,BUFFER,KST,NERR)
cloli* 'COMMON/CNTRLS/TIME,SK2(69),XAC,XINFRQ,XFNFRQ,XTYPFQ,XNFRQS,'//
cloli* ' SK4(3),FREQ',71,NERR)
cloli  only FREQ is used; it is attended with equivalence
      CALL WTSPTP(BLANK,'COMMON /CNTRLS/ CTROLS(160)',27,NERR)
      CALL WTSPTP(BLANK,'EQUIVALENCE(CTROLS(79),FREQ)',28,NERR) 
      CALL DEFPRM
      IF (NCL(11)+NCL(17))  28,28,25
 25   IST = 1
      call cpy('COMMON/XMR/',1,BUFFER,IST,11)
      call acdim(MRI,IST,11,11,3)
      CALL WTSPTP(BLANK,BUFFER,IST-2,NERROR)
      KST=1
      CALL CPY('DIMENSION VORK(   ) ',INT1,BUFFER,KST,20)
      KST=16
      CALL CPY(BCDNCL(21),INT1,BUFFER,KST,INT3)
      CALL WTSPTP(BLANK,BUFFER,20,NERR)
   28 IF(NCL(1)+NCL(14)+NCL(16)) 35,35,29
   29 IST=1
      CALL CPY('COMMON/MRG/',1,BUFFER,IST,11)
      CALL ACDIM(MRGI,IST,21,21,4)
      CALL WTSPTP(BLANK,BUFFER,IST-2,NERROR)
   35 CALL ACIV(0)
CLOLI IF (CTROLS(117).EQ.0.)  GO TO 41
      IF (NINT(CTROLS(117)).EQ.0)  GO TO 41
      REWIND (iqqltr)
   40 READ (iqqltr,'(9A8)',END=41) TAPE
      WRITE (iqqact,'(9A8)')        TAPE
      GO TO 40
   41 CALL WTSPTP(BLANK,'DATA S/.0174532925/',19,NERR)
      CALL WTSPTP(BLANK,
     * 'FRZ(A,C)=DCMPLX(A*DCOS(C),A*DSIN(C))',36,NERR)
      CALL WTSPTP(BLANK,
     * 'FPZ(A,C)=DCMPLX(A*DCOS(C*S),A*DSIN(C*S))',40,NERR)
      CALL WTSPTP(BLANK,'FCZ(A,C)=DCMPLX(A,C)',20,NERR)
      CALL WTSPTP(BLANK,'CALL V1CALC (B14,B17,OMEGA,1)',29,NERR)
      CALL WTSPTP(BLANK,'CALL I4CALC (OMEGA)', 19,NERR)
      CALL WTSPTP(BLANK,'CALL V6CALC (B36,B86,M36,M66,OMEGA,1)',37,NER)
      CALL WTSPTP(BLANK,'CALL V3CALC (M36,M33,OMEGA)',27,NERR)
      IF (NCL(1)+NCL(14)+NCL(16))  60,60,50
   50 CALL WTSPTP(BLANK,'CALL IV25(MRGI,VORK,B24,B27,B35,B85)',36,NERR)
      GO TO 65
   60 CALL WTSPTP(BLANK,
     * 'CALL V2CALC (B24,B25,B27,B35,B85, MRI,VORK,1) ',46,NERR)
      CALL WTSPTP(BLANK,'CALL V5CALC (B25,B35,B85,1)',27,NERR)
CLO65 IF (VECEQS.EQ.0.)  GO TO 75
   65 IF (NINT(VECEQS).EQ.0)  GO TO 75
      CALL WTSPTP(BLANK,'CALL IYCALC(B2Y,B3Y,B8Y,BXY)',28,NERR)
      CALL WTSPTP(BLANK,'CALL I7CALC(B17,B27,B37,B87,BX7)',32,NERR)
      CALL WTSPTP(BLANK,'CALL V8CALC(B84,B85,B86,B87,B8Y)',32,NERR)
      CALL WTSPTP(BLANK,'CALL VXCALC(BX4,BX5,BX7,BXY)',28,NERR)
   75 CALL WTSPTP(BLANK,'OUTBFR (  1)=FREQ  ',17,NERR)
cloli
      call WTSPTP(BLANK,'IF(1.GT.2)PRINT *,KWAY',22,NERR)
      RETURN
 
      END
