package Desdexml;
#Para interpretar y adaptar XML
#usados por simusol1.pl
use Data::Dumper;
use GlobalesSimusol;
use TraAbrev;
use Ayudas;
use Elementos;
use Algebraico;
use Ampliaciones;
use Auxiliares;
use Controles;
use Prograf;
use Sceptre;
use Tablasfuncq;
use strict;
use warnings;
our ($codcontexto,$codconattrib,$codconhandles ,$codnodos,$codigno
     ,$codelems,$codconects,$codconectsnonodos)
          =('[JECRLTZNntO?]','[O]','[lxX]','[Nnt]','[A]'
	  ,'[JECRLT]','[JECRLTZNntl]','[JECRLTZ]'); 
$Controles::codconhandles = $codconhandles;
$Controles::codelems = $codelems;
$Controles::codnodos = $codnodos;
$Ampliaciones::codelems = $codelems;
$Ampliaciones::codnodos = $codnodos;
$Ampliaciones::codconhandles = $codconhandles;

BEGIN {
     use Exporter ();
     our ($VERSION,@ISA,@EXPORT,@EXPORT_OK,%EXPORT_TAGS);
     @ISA=qw(Exporter);
     @EXPORT=qw(&traducir &traducirxml &marcar_nodos
		$codnodos $codconhandles $codelems $codconects
	       );
};
END();
our @listaCORTOA;
# ---------------------------------------------------------------------------
sub traducir{
  comfin('comd traducir',@_);
  my @archivos = @_; my ($coderr,$mensaje);
  my $pwdori =`pwd`;chomp $pwdori; $pwdori .= '/';
  $GlobalesSimusol::pwdori = $pwdori;
  $GlobalesSimusol::PRINCIPAL = '';  
  my ($arch, $codcirc, $refcirc, $refarchele, $refarchmod, $refarchuni
      ,$reffalta_modelo, $reffalta_nombre, $reffalta_pcs, $reffalta_plantilla)
          = ('', '', [], [], [], [], {}, {}, {}, {});
  if (@archivos == 1) {
      $arch = $archivos[0];
      mensaje_principal($arch); 
      $GlobalesSimusol::PRINCIPAL = $arch;
      ($coderr,$codcirc) = traducirxml($arch);
      $refcirc = $reffi{$arch};
      impr_debug(__LINE__.' Desd $refcirc->{clasearch}'
        ,$refcirc->{clasearch}); 
      $coderr and parar1($coderr,$refcirc);
  } else { 
      (my $coderr,$arch,my $mensaje,$refarchmod,$refarchele,$refarchuni) 
          = elegir_principal(\@archivos);
      if ($coderr) {
          comfin('find traducir $coderr,$arch,$mensaje',$coderr,$arch,$mensaje);	  
          return $coderr,'',$mensaje;
      };	  
      $refcirc = $reffi{$arch};
      system "rm $arch.d $arch.paraplot 2>/dev/null";
      $GlobalesSimusol::PRINCIPAL = $refcirc->{CORTO}; 
      mensaje_principal($arch);
      $codcirc = 'circuito'; $refcirc->{clasearch} = 'circuito';
  };
      impr_debug(__LINE__.' Desd $refcirc->{clasearch}'
        ,$refcirc->{clasearch}); 

  #impr_debug(__LINE__.' Desd $codcirc $refarchmod,$refarchele,$refarchuni'
  #	     ,[$codcirc, @$refarchmod, @$refarchele, @$refarchuni]);
  foreach my $refu (@$refarchuni) {
      definir_UNIDADES($refu); #PRIMERO, de los explicitos
  };
  if (defined $refcirc->{refvalores}->{UNIDADES}) {
      $coderr = definir_UNIDADES($refcirc); #SEGUNDO del princ. circ o mod
          return $coderr if $coderr;
      delete $refcirc->{refvalores}->{UNIDADES};
  };
  if ($codcirc eq 'circuito' or $codcirc eq 'modelo') {
      $reffalta_pcs = {};$reffalta_plantilla = {};
      defined $refcirc->{tienepcs} 
          and  %$reffalta_pcs = %{$refcirc->{tienepcs}};
      defined $refcirc->{tieneplantilla}  
          and %$reffalta_plantilla = %{$refcirc->{tieneplantilla}};
       impr_debug(__LINE__.' Desd $refcirc->{clasearch}'
        ,$refcirc->{clasearch}); 
      
      if ($codcirc eq 'circuito') {
          if (defined $refcirc->{tienemodelo}) {
	      ($reffalta_modelo, $reffalta_nombre)
                 = modelos_requeridos($refcirc);
              $refarchmod 
                  = preparar_para_modelos($refcirc, $refarchmod
                                 , $reffalta_pcs, $reffalta_plantilla
                                 ,$reffalta_modelo, $reffalta_nombre);
          } else {
              $refarchmod = [];
          };
      };
        impr_debug(__LINE__.' Desd $refcirc->{clasearch}'
        ,$refcirc->{clasearch}); 
    if (scalar keys %$reffalta_pcs) { 
	  impr_debug(__LINE__.' Desd $reffalta_pcs', Dumper $reffalta_pcs);
          impr_debug(__LINE__.' Desd $reffalta_plantilla'
             , Dumper $reffalta_plantilla);
          # Aqui toma, CUARTO unidades de los archivos .ele
          completar_eles($refcirc, $refarchele
               , $reffalta_pcs, $reffalta_plantilla);
      };
      ($CORTOA,$PROPIOA,$CORTOASINDIA,$PROPIOASINDIA) 
         = @$refcirc{'CORTO','PROPIO','CORTOSINDIA','PROPIOSINDIA'};
      $reffalta_pcs= {};
      foreach my $key (keys %$reffalta_pcs) {
          $DEFIELE->{datospcs}->{$key} or $reffalta_pcs->{$key} = 1;
      };
      scalar keys %$reffalta_pcs  and  
      do {my $cualesiconos = '';
          map (do{$cualesiconos .= descripcion_icono($_) ."\n"}
               , keys %$reffalta_pcs);
          parar1(246, $refcirc, "Falta definicion de íconos");
      };
      foreach my $plantilla (keys %{$refcirc->{tieneplantilla}}) {
          defined $DEFIUNI->{$plantilla} 
              or $reffalta_plantilla->{$plantilla} = 1
      };
      scalar keys %$reffalta_plantilla and
           # toma QUINTO UNIDADES de los especialmente buscados
           completar_unis($refcirc,$refarchuni,$reffalta_plantilla);
      #impr_debug(__LINE__.' Desd $DEFIUNI',Dumper $DEFIUNI);
  };
  if ($codcirc eq 'circuito') {
      foreach my $archm (@$refarchmod) {
          ($coderr,$reffalta_modelo) 
	      = completar_traduccion_capas(
                 $archm,$reffalta_modelo,$reffalta_pcs); # modelos
	  impr_debug(__LINE__.' Desd termine completar_traduccion_capas'
		     ,'____');
          $coderr and parar1($coderr,$refcirc
        , "El archivo de definicion de modelo parecia bueno pero no sirve
           $archm");
      };
      #impr_debug(__LINE__.' Desd $defimod', Dumper $defimod);
      #impr_debug(__LINE__.' Desd $reffalta_modelo', Dumper $reffalta_modelo);
      ($CORTOA,$PROPIOA,$CORTOASINDIA,$PROPIOASINDIA) 
         = @$refcirc{'CORTO','PROPIO','CORTOSINDIA','PROPIOSINDIA'};
      #scalar keys %$reffalta_modelo  and  
      #do {my $cualesmod = '';
      #    foreach my $key (keys %$reffalta_modelo) {
      #        my $icono = descripcion_icono($key);
      #        my @mods = keys %{$reffalta_modelo->{$key}};
      #        $cualesmod .= "$icono: @mods\n"; 
      #    };
      #    parar1(247, $refcirc, "Falta definicion de modelos\n$cualesmod");
      #};
      ($coderr) = completar_traduccion_capas($arch); #principal, circuito
      ($CORTOA,$PROPIOA,$CORTOASINDIA,$PROPIOASINDIA) 
         = @$refcirc{'CORTO','PROPIO','CORTOSINDIA','PROPIOSINDIA'};
  } else {
      $coderr = completar_traduccion_capas($arch); #princ, no circ.
	  impr_debug(__LINE__.' Desd termine completar_traduccion_capas'
		     ,'____');
      $coderr and  parar1($coderr,$refcirc);      
      if ($codcirc eq 'modelo') {
      } elsif ($codcirc eq 'grafico') {
          prograficar($refcirc);
          parar1(2,$refcirc); 
      } else {# elementos  
          parar1(1,$refcirc);
      };
  };       
  comfin('find traducir',$coderr,$arch, $mensaje); #aqui se llega sin error 
  return $coderr,$arch,$mensaje;
}# traducir 
# ---------------------------------------------------------------------------
sub completar_unis{
  comfin('comd completar_unis',@_);
  #my $debug1 = $debug; $debug = '';
  my ($refcirc, $refarchuni, $reffalta_plantilla) = @_; 
  my (@archunibuenos, @plantillass);
  foreach my $archuni (@$refarchuni) {
      my $refuni = $reffi{$archuni};
      my @plantillas = keys %{$refuni->{tieneplantilla}}; 
      #impr_debug(__LINE__.' Desd @plantillas', [$archuni,@plantillas]);
      my $ya = '';
      foreach (@plantillas) {
          $reffalta_plantilla->{$_} and do{ $ya = 1; last};
      };
      $ya  and  push @archunibuenos, $archuni;
  };
  #impr_debug(__LINE__.' Desd @archunibuenos', \@archunibuenos);
  foreach my $plantilla (keys %{$reffalta_plantilla}) {
      my $nomplantilla = $nombreplantilla->[$plantilla];
      my @lista = conseguir_nombres_ele_mod($refcirc,$nomplantilla,'uni');
      #impr_debug(__LINE__.' Desd @lista', \@lista);
      foreach my $archuni (@lista) {
          defined $reffi{$archuni} and next;
          my ($coderr,$codcirc)  = traducirxml($archuni);     
          $coderr and do {porparar1($coderr,0); next};
          $codcirc ne 'unidades' and next;
          my $refuni = $reffi{$archuni};
          if (defined $refuni->{refvalores}->{UNIDADES}) {
	      $coderr = definir_UNIDADES($refuni); #QUINTO buscados
              $coderr and  porparar1($coderr,$reffi{$archuni});
          };
      };
  };
  #$debug = $debug1;
  comfin('find completar_unis',@_);
  return '';
} #
# ----------------------------------------------------------------------------
sub completar_eles{
  comfin('comd completar_eles',@_);
  my $debug1 = $opt_hash{d}; #$debug = '';
  my ($refcirc, $refarchele, $reffalta_pcs, $reffalta_plantilla) = @_;
  #impr_debug(__LINE__.' Desd',Dumper $_[2]);
  #impr_debug(__LINE__.' Desd $reffalta_pcs', $reffalta_pcs);
  #impr_debug(__LINE__.' Desd $reffalta_plantilla}', $reffalta_plantilla);
  my @archeleposibles = @$refarchele; 
  foreach my $plantilla (keys %{$reffalta_plantilla}) {
      my $nomplantilla = $nombreplantilla->[$plantilla];
      #impr_debug(__LINE__.' Desd $nomplantilla', $nomplantilla);
      push @archeleposibles, 
          conseguir_nombres_ele_mod($refcirc,$nomplantilla,'ele');
  };
  foreach my $archele (@archeleposibles) {
      if (defined $reffi{$archele}) {
          $reffi{$archele}->{clasearch} eq 'elementos' or next;
      } else {       
          my ($coderr,$codcirc)  = traducirxml($archele);     
          $coderr and do {porparar1($coderr,0); next};
          $codcirc eq 'elementos' or next;
      };
      my $refele = $reffi{$archele};
      my @pcseles = keys  %{$refele->{tienepcs}};
      #impr_debug(__LINE__.' Desd @pcseles', [$archele,@pcseles]);
      my $ya = '';
      foreach (@pcseles) {
          $reffalta_pcs->{$_} and do{ $ya = 1; last};
      };
      not $ya  and  next;
      my $coderr = completar_traduccion_capas($archele,$reffalta_pcs); # eles
      $coderr and porparar1($coderr,0,$archele);
  };
  $debug = $debug1;
  comfin('find completar_eles');
  return ;
}# completar_eles 
# ----------------------------------------------------------------------------
sub modelos_requeridos{
  comfin('comd modelos_requeridos',@_);
  my $refcirc = $_[0];
  my ($reffalta_modelo,$reffalta_nombre) = ({},{});
  foreach my $il (@{$refcirc->{capas}}) {
      my $reflay = $reflayer[$il];
      foreach my $numobj (keys %{$reflay->{refvalores}->{DATOS}}) {
          my @renglones = @{$reflay->{refvalores}->{DATOS}->{$numobj}};
          @renglones = juntar_por_signos_y_paren('',@renglones);
	  #impr_debug(__LINE__.' Desd @renglones',Dumper \@renglones);
          foreach my $renglon (@renglones) {
              next if $renglon =~ /^s*;/;
              $renglon =~ s/^(\w+)\s*,/$1=/;
	      #impr_debug(__LINE__.' Desd $renglon', $renglon);
              my @partes = split /\s*=\s*/, $renglon;
              if ($partes[0] =~ /^(T\w+)\s*/i
                   and  $partes[-2]=~ /^(T\w+)\s*/i) {
	             my $obj = $refcirc->{cualobjmodelo}->{uc($1)};
                      my $pcs
                         = $plantillalista->[$obj].'c'.$shapelista->[$obj];
                      $partes[-1] =~ s/^\s*,//;
                      my @partecitas = split /\s*,\s*/, $partes[-1];
                      my $nombre = uc($partecitas[0]);
                      $reffalta_modelo->{$pcs}->{$nombre} = 1;
                      $reffalta_nombre->{$nombre} = 1;
	       } elsif ($partes[0] =~ /^(T\w+)\s*/i) {
                  parar1(66,$refcirc,
                    "En cuadro DATOS hay renglones mezcados\n $renglon\n
             quizás se pegaron renglones que terminaban erroneamente en coma");

	      }; #if
          };
      };
  };
  #impr_debug(__LINE__.' Desd $reffalta_nombre', Dumper $reffalta_nombre);
  comfin('find modelos_requeridos');
  return $reffalta_modelo,$reffalta_nombre; 
} 

# ----------------------------------------------------------------------------
sub preparar_para_modelos {
  #determina los archivos que pueden proveer los modelos requeridos y aumenta 
  #$reffalta_pcs y $reffalta_plantilla 
  comfin('comd preparar_para_modelos',@_);
  my ($refcirc, $refarchmod, $reffalta_pcs, $reffalta_plantilla
       , $reffalta_modelo, $reffalta_nombre) = @_;

  my @archmodposibles = @$refarchmod;
  foreach my $nombrev (sort keys %$reffalta_nombre) {
      push @archmodposibles,
            conseguir_nombres_ele_mod($refcirc,$nombrev,'mod');
  };
  my @archmodrevisados;
  impr_debug(__LINE__.' Desd @archmodposibles', \@archmodposibles);
  foreach my $archmod (@archmodposibles) {
      my $refm = $reffi{$archmod}; 
      if (defined $refm) {
          $refm->{clasearch} eq 'modelo' or next;
      } else {
          my ($coderr,$codcirc)  = traducirxml($archmod);     
          $coderr and do {porparar1($coderr,$refm); next};
	  #impr_debug(__LINE__.' Desd $codcirc',$codcirc);
          $codcirc eq 'modelo' or next;
          $refm = $reffi{$archmod}; 
          my $posible ='';
          my @pcsmodelos = keys %{$refm->{tienemodelo}};
          #impr_debug(__LINE__.' Desd @pcsmodelos',\@pcsmodelos );
          #impr_debug(__LINE__.' Desd $refm',$refm->{tienemodelo} );
          @pcsmodelos == 1 or 
          do { porparar1(242,$refm
             , "Aquí debe aparecer un solo tipo de ícono de modelo");
	       next;
          };
          foreach my $pcsmodelo  (@pcsmodelos) {
              defined $reffalta_modelo->{$pcsmodelo} and
              do {$posible = 1}               
          };
          $posible or next;
      }; 
      my (@modelos, @idens);
      foreach my $il (@{$refm->{capas}}) {
          my $reflay = $reflayer[$il]; 
          foreach my $numobj (keys %{$reflay->{refvalores}->{USO}}) {
              my @renglones = @{$reflay->{refvalores}->{USO}->{$numobj}};
              @renglones = juntar_por_signos_y_paren('',@renglones);
              map (do 
                {/\s*(T\w+)\s*=\s*(\w+)/ and $reffalta_nombre->{uc($2)} and
		 push @idens,$1 and push @modelos, uc($2)}, @renglones);
          };
      };
      @modelos or next;
      impr_debug(__LINE__.' Desd @modelos, @idens',[@modelos, @idens]);
      for (my $j = 0; $j < @modelos; $j++) {
           my $iden  = $idens[$j]; my $nombre = $modelos[$j]; 
           my $obj = $refm->{cualobjmodelo}->{uc($iden)};
           my $pcs = $plantillalista->[$obj].'c'.$shapelista->[$obj];
           if ($reffalta_modelo->{$pcs}->{$nombre}) {
               push @archmodrevisados, $archmod; 
               delete $reffalta_modelo->{$pcs}->{$nombre};
               #delete $reffalta_nombre->{$nombre};
           } else { 
               delete $idens[$j]; delete $modelos[$j];
           }; 
 
      };
      @modelos = grep ( defined $_, @modelos);
      @modelos or next;
      map($reffalta_pcs->{$_} = 1, keys %{$refm->{tienepcs}});
      impr_debug(__LINE__.' Desd $refm->{tienepcs}'
        ,Dumper $refm->{tienepcs}); 
      foreach my $plantilla (keys %{$refm->{tieneplantilla}}) {
          $reffalta_plantilla->{$plantilla} = 1;
          # Toma unidades. TERCERO, de los archivos de modelos
	  not defined $DEFIUNI->{$plantilla} and
             defined $refm->{refvalores}->{UNIDADES} and
	  do {definir_UNIDADES($refm); #TERCERO de los modelos
              delete $refm->{refvalores}->{UNIDADES};
	  };
      };
      map (do { scalar keys %{$reffalta_modelo->{$_}}
             or delete $reffalta_modelo->{$_}} , keys %$reffalta_modelo);
   #   scalar keys %$reffalta_modelo or last;
  }; #
  impr_debug(__LINE__.' Desd $reffalta_modelo', Dumper $reffalta_modelo);
  map (do { scalar keys %{$reffalta_modelo->{$_}}
             or delete $reffalta_modelo->{$_}} , keys %$reffalta_modelo);
 # scalar keys %$reffalta_modelo and
 # do {parar1(250, $refcirc,"Faltan definiciones para modelos")};
  comfin('find preparar_para_modelos', @archmodrevisados);
  return \@archmodrevisados;
} #preparar_para_modelos
# ----------------------------------------------------------------------------
sub conseguir_nombres_ele_mod {
  comfin('comd conseguir_nombres_ele_mod', @_);
  my ($refcirc,$nombrev,$ext,$modo) = @_; my $extra = '\w*'; 
  my $largo2;
  my $case = 'i'; 
  $case = '' if $modo;
  if ($ext eq 'ele') {
      $largo2 = 'elementos';
  } elsif ($ext eq 'mod') {
      $largo2 = 'modelos'; 
  } elsif ($ext eq 'uni') {
      $largo2 = 'elementos';
  } elsif ($ext eq '') {
      $largo2 = 'archivos'
  };
    my $precomando = '/^$nombrev$extra\.{0,1}$ext'; my $comando;
  if ($ext ne '') {
     $comando = $precomando . '$/' . $case . '  or  ' 
              . $precomando . '\.dia$/' . $case;
  } else {
     $comando = $precomando . '$/' . $case ;
  };
  impr_debug(__LINE__.' Desd $nombrev $ext $largo2 $SIMUSOLLIBDIR'
            ,[$nombrev, $ext, $largo2, $SIMUSOLLIBDIR]);
  my $BASEARCH = $refcirc->{BASEARCH};
  opendir(TRABAJO,"$BASEARCH");
  my  @dirarray1 = readdir TRABAJO;closedir TRABAJO;
  @dirarray1 = sort grep (do {eval($comando)},@dirarray1); #para poder comparar 
  @dirarray1 = map($_ = $BASEARCH . $_, @dirarray1);
  # se trabaja, si es posible, con el nombre propio 
  # (del mismo directorio que el circuito)
  my @dirarray2;
  if (-e "$HOMEDIR/.simusol/$largo2") {
      opendir(TRABAJO,"$HOMEDIR/.simusol/$largo2");
      @dirarray2 = readdir TRABAJO;closedir TRABAJO;
 #  impr_debug(__LINE__.' Desd',["$HOMEDIR/.simusol/$largo2",'   ',@dirarray2]);
      @dirarray2 = sort grep (do {eval($comando)}, @dirarray2);
      map( $_ = "$HOMEDIR/.simusol/$largo2/$_",@dirarray2);
  };
  opendir(TRABAJO,"$SIMUSOLLIBDIR\/simusol\/$largo2");
  my @dirarray3 = readdir TRABAJO;closedir TRABAJO;
  #impr_debug(__LINE__.' Desd @dirarray3',Dumper \@dirarray3);
  @dirarray3 = sort grep (do {eval($comando)}, @dirarray3);
  map( $_ = "$SIMUSOLLIBDIR/simusol/$largo2/$_",@dirarray3);
  explic("Busco definición de $largo2  $nombrev (mayúsc. o minúsc) en:\n"
       . join ("\n",@dirarray1,@dirarray2) )
       if (scalar @dirarray1 + scalar @dirarray2);
  my @lista = (@dirarray1,@dirarray2,@dirarray3);
  comfin('find conseguir_nombres_ele_mod', @lista);
  return @lista;
}
# ----------------------------------------------------------------------------
sub mensaje_principal{ 
    comfin('comd mensaje_principal',@_);
  #cuando se conoce el archivo principal se registra el mensaje
  # el archivo LSS1 ya fue abierto, con nombre $arch.lss1 o 'simusol.lss1'
  my $arch = $_[0];
  if ($arch =~ /^(.*\/)([\/]+)$/) {
#          $GlobalesSimusol::pwdori =   $1;
  };
  my ($BASEARCH, $PROPIO, $CORTO, $PROPIOSINDIA, $CORTOSINDIA)
     = relativizar($arch,$GlobalesSimusol::pwdori);
  my $date = scalar localtime((stat $arch)[9]);
  my $PROPIOrelleno = $PROPIO;
  $PROPIO eq $PROPIOSINDIA and $PROPIOrelleno .= '    ';
  #impr_debug(__LINE__.' Desd $CORTO', "principal es $CORTO");
  mensaje('=-' x 2 .
              "Mensajes de simusol1.pl,          $PROPIOrelleno,      "
                  . $date );
}#mensaje_principal
# ---------------------------------------------------------------------------
sub elegir_principal{
  comfin('comd elegir_principal',@_);
  my $refarchivos = $_[0];
  my ($coderr, $mensaje,$principal) = ('','','');
  my ($refarchcir, $refarchmod,$refarchele,$refarchuni)
          = ([],[],[],[]);
  # analiza con traducirxml los archivos, ignorando 
  # los que tienen errores, dejando en conserva 
  #los 'elementos','modelo','unidades'
  # y propone elegir uno como principal entre los restantes
  foreach my $arch (@$refarchivos) {
      defined $clasearchivos{$arch} and $clasearchivos{$arch} eq 'compl' 
          and next;
      my ($coderr) = traducirxml($arch);
      #impr_debug(__LINE__.' Desd hashCUADROS', $reffi{$arch}->{hashCUADROS});
      $coderr and do {porparar1($coderr, 0,'',$arch); next};
      my $refcirc = $reffi{$arch}; 
      my $codcirc= $refcirc->{clasearch};
      impr_debug(__LINE__.' Desd $codcirc',[$arch,$codcirc]);
      my @CUADROS = keys %{$refcirc->{hashCUADROS}};
      #impr_debug(__LINE__.' Desd hashCUADROS', \@CUADROS);
      @CUADROS == 1 and $CUADROS[0] eq 'UNIDADES' and $codcirc = 'unidades';
      #mirar mas los cuadros para detectar 'compl' y 'uni'
      if ($codcirc eq 'circuito') {
	  push @$refarchcir,$arch;
      } elsif ($codcirc eq 'elementos') {
          push @$refarchele, $arch;
      } elsif ($codcirc eq 'modelo') {
          push @$refarchmod, $arch;
      } elsif ($codcirc eq 'unidades') {
          push @$refarchuni, $arch;
      };
  };    
  impr_debug(__LINE__.' Desd $refarchcir',$refarchcir);
  if (@$refarchcir > 1) {
      $mensaje = " Hay mas de un posible circuito :
      @$refarchcir;
        Concrete su pedido"; $coderr = 100;
  } elsif (@$refarchcir == 1) {
    $principal = $refarchcir->[0];
  } elsif (@$refarchivos == 0) {
      $mensaje = ' No hay ningun diagrama  que necesite ser tratado'; $coderr = 100;
  } elsif (@$refarchivos == 1) {
      $principal = $refarchivos->[0];
  };
  comfin('find elegir_principal',$coderr,$principal,$refarchmod,$refarchele,$refarchuni); 
  # si llega aqui, no hubo error
  return $coderr,$principal, $mensaje,$refarchmod,$refarchele,$refarchuni;  
}#elegir_principal
# ----------------------------------------------------------------------------
sub traducirxml{
  comfin('comd traducirxml', @_); #puede terminar, por error, sin aviso fin
  my ($archivo,$principal) = @_;
  my $coderr = 0;
  explic("Traduciendo el archivo $archivo");
  my ($ilayer,$ij);  #num de capa  y de objeto en Simusol; 
  #num de objeto de simusol; cota de indice anterior
  $reffi{$archivo} = {};
  my $refcirc= $reffi{$archivo}; 
  $refcirc->{archivo} = $archivo;
  ($BASEARCHA, $PROPIOA, $CORTOA, $PROPIOASINDIA, $CORTOASINDIA)
     = @$refcirc{'BASEARCH', 'PROPIO', 'CORTO', 'PROPIOSINDIA','CORTOSINDIA'}
     = relativizar($archivo,$GlobalesSimusol::pwdori);
  $refcirc->{ABSOLUTO} = $BASEARCHA . $PROPIOA;
  $reffi{$BASEARCHA . $PROPIOA} = $refcirc;
  $refcirc->{conversion} = {};
  $refcirc->{clasearch} = 'dibujo'; #si todo va bien se cambiará ...
  my $conver_obj = $refcirc->{conversion};
  # con $conver_obj se convierte numero de objeto dentro del diagram 
  # a numero de objeto dentro del simusol 
  my $p = XML::Parser->new(Style=>'Tree');
  my $doc;
  eval{$doc=$p->parsefile($archivo)};
  $@ eq '' or # quizas esta comprimido,que es el modo natural de Dia
  do {   -e 'gnus' or crear_gnus('./');
      system "zcat $archivo >gnus/llll";  
      eval{$doc=$p->parsefile("gnus/llll")};
        $@ eq '' or
        do{porparar1(251,0,"$@\n      No es un buen archivo XML",$archivo);
             return 251;#0 porque no corresponde crear el archivo .lss1
	};
  };
  $doc->[0] eq "dia:diagram" or 
  do {porparar1(252,0,"No es un \"dia:diagram\"",$archivo );
      return 252;#0 porque no corresponde crear el archivo .lss1
  };#do       
  my $diagrama=$$doc[1];  #ref. a lista de listas arboladas 
  #imprlisarb(__LINE__.' Desd  diagrama ',$diagrama);
  my @layers=selectags("dia:layer",$diagrama); 
  #imprlislisarb (__LINE__.' Desd layers ',@layers);
  # $reflay tendra toda la informacion de la capa
  # $recirc tendra toda la informacion sobre el diagrama
  #hash de hash;
  #keys secundarias 'refvalores' ,'lisobjconectsnonodos',lisobjnodos',
  #'lisobjmodelos', ....; values referencia a listas....
  #sus values serán hashes de referencias a datos de los circuitos
  my $ilayerfile = -1;# se usa para nombrar a la capa dentro de su archivo
  foreach my $ref (@layers) {
      $ilayerfile ++;
      my $nomlayer = $ref->[0]->{name} ."($ilayerfile - $archivo)" ;
      $ilayer = scalar @$nombrelay;
      #algun día podria haber mas de un circuito por archivo; no por ahora
      #nombrando las capas adecuadamente
      push @{$refcirc->{capas}}, $ilayer;
      my $reflay=$reflayer[$ilayer] = {};
      $reflay->{capa} = $ilayer;
      $reflay->{refcirc} = $refcirc;
      #no se pueden juntar en un solo comando
      $reflay->{ilayer}=$ilayer;

      #REVISAR hace falta este control?
      $cuallay->{$nomlayer} = $ilayer; 
      push @$nombrelay,$nomlayer;

      crearfantasma($ilayer);
      $reflay->{refcirc} = $refcirc;
      $reflay->{reffile} = $reffi{$archivo};
      desagrupar($ref); #para que agrupar objetos con Dia no afecte a Simusol  
      my @objes=selectags("dia:object",$ref);
      foreach my $rr (@objes) {
          $ij = scalar @$codlista;
          my $id = $rr->[0]->{id}; 
          my $type = $rr->[0]->{type};
          my $ifile = $id;
          $ifile =~ s/^O(\d*)/$1/ or 
          do {         
              porparar1(253,0,"¿Objeto con     Id=$ifile ? 
              el diagrama ha sido modificado!",$archivo);
              return 253;
          };
          my $textitoori = uc(string('text',$rr));
          $textitoori =~  s/^\s*(.+)\s*$/$1/;
          my $textito = $textitoori;
          $textito =~ s/\s+//g;
          push @$textolista,$textito;
          my ($sheet,$descrig) = ('descon',$type);
          ($sheet,$descrig) = ($1,$2) if  $type =~ /(.+) - ([^-]+)$/; 
          my ($codi,$codival,$plantilla,$shape); 
          $shape = $cualshape->{$descrig};
          if (not defined $shape) {
              $shape = scalar @$nombreshape;
	      push @$nombreshape,$descrig;
	      $cualshape->{$descrig} = $shape; 
          };#if not defined $shape
          push @$shapelista,$shape;
          $plantilla = $cualplantilla->{$sheet};
          if (not defined $plantilla) {
              $plantilla = aumentar_plantilla($sheet);
          };#if not defined $plantilla
          push @$plantillalista,$plantilla;  
          $refcirc->{tieneplantilla}->{$plantilla} = 1 if $plantilla > 4;
          my $codigosref = $codigoStandard{$descrig};
          my $pcs = $plantilla . 'c' . $shape;
          if ($descrig eq 'nodo') {
              $codi = $codival = 'N';
              $refcirc->{NODOSPLANT}->{$textito} = $plantilla;
          } elsif ($descrig eq 'nodod') {
              $codi = $codival = 'n';
              $refcirc->{NODOSPLANT}->{$textito} = $plantilla;
	  } elsif ($sheet eq 'UML' 
                   and ($descrig eq 'Object' or $descrig eq 'Objet')) {
	      $codi = $codival = 'O';
              $textolista->[-1] = $textitoori;
          } elsif (lc($sheet) eq 'modelos' or lc($descrig) eq 'modelo') {
              $codi = $codival = 'T';
              $refcirc->{cualobjmodelo}->{"T$textito"} = $ij;
              $refcirc->{tienemodelo}->{$pcs} = 1; 
          } elsif ($sheet eq 'Standard') {
              ($codi,$codival) = @$codigosref;
          };
          #impr_debug(__LINE__.' Desd $ij $codi $codival $sheet - $descrig ',
	  #	     [$ij, $codi, $codival, "$sheet - $descrig"]);

	  defined $codi or     #candidato a elemento     
          do {
              $codi = $comocod->{$pcs};
	      $codival = $comocodvalor->{$pcs};
          };
          defined $codi or #aun no está definido
          do {
              $codi = 'Z';$codival = 'Z';
 	      $descrig = ''; #$codigovalor{$descrig} será 'Z'
          };#do
          $refcirc->{tienepcs}->{$pcs} = 1 
             if $plantilla > 4 and $codi !~ /[NnT]/;
          push @$codlista,$codi;
          push @$codvalorlista,$codival;
          push @$laylista,$ilayer;
          #$i el numero identificatorio de objeto que aparece en el archivo
          #$ij  numero de orden de encuentro de objeto en  simusol
          $conver_obj->{$ifile} = $ij; 
          push @{$reflay->{lisobjtodos}},$ij;
          push @{$refcirc->{lisobjtodos}},$ij;
          my $j = selec('dia:attribute','name','obj_pos',$rr);
          my $jj = selec0('dia:point',$rr->[$j+1]);
          my $lugar={val=>$rr->[$j+1][$jj+1][0]{val}};
          push @$lugarlista,mejorar_lugar($rr->[$j+1][$jj+1][0]);
          $coderr = tratar_cod($reflay,$rr,$ij,$descrig,$archivo);
          $coderr and return $coderr;
     }; # foreach ...@objes
      #controlar_our(); 
      #un circuito puede estar descripto en mas de una capa;
      # y tener ramas en una y no en otras  
      $coderr = controlar_layer($ilayer);
      #impr_debug(__LINE__.' Desd $coderr luego controlar_layer',$coderr);
      return $coderr if $coderr; 
      if (defined $reflay->{refvalores}->{ARCHIVOS_COMPLEMENTARIOS}) {
          interpretar_archivos_complementarios($ilayer, $archivo); 
          # los archivos complementarios son archivos de texto con 
          # cuadros del archivo que se esta procesando
      };
      if (defined $reflay->{refvalores}->{DIAGRAMAS_COMPLEMENTARIOS}) {
          error_progr(__LINE__.' Desd', "DIAGRAMAS_COMPLEMENTARIOS");
          # declara clasearchivos{} = 'compl'
          #aun no programado  
      };
       if (defined $reflay->{refvalores}->{USO_DEF}) {
          push @{$refcirc->{clasecapa}}, 'elementos';
      } elsif  (defined $reflay->{refvalores}->{USO} and  
                (defined $reflay->{refvalores}->{DEFINICION} or
                 defined $reflay->{refvalores}->{DIAGRAMAS_COMPLEMENTARIOS})) {
          push @{$refcirc->{clasecapa}}, 'modelo';
      } else {
          my @cuadros = union_conjunto(keys %{$reflay->{refvalores}});
	  #impr_debug(__LINE__.' Desd @cuadros', \@cuadros);
          if (@cuadros == 0 and defined $refcirc->{refvalores}->{UNIDADES}) {
              push @{$refcirc->{clasecapa}}, 'unidades';
          } elsif (@cuadros == 1 
		   and defined $reflay->{refvalores}->{GRAFICOS}) {
              push @{$refcirc->{clasecapa}}, 'grafico'; 
          } else { 
              push @{$refcirc->{clasecapa}}, 'circuito';
          };
      };
      if (defined $reflay->{lisramascrudas}) {
          guardar_conex($reflay); #en  traducirxml
          enganchar_ele($reflay,'en traducirxml');
      }; 
  }; #  (@layers)
  #impr_debug(__LINE__.' Desd $refcirc->{clasecapa}', $refcirc->{clasecapa});
  my @clases = union_conjunto(@{$refcirc->{clasecapa}});
  @clases >1 and 
  do {porparar1(241,$refcirc,"El diagrama contiene capas de distintas clases:
      @clases"); 
      return 241;
  };
  $refcirc->{clasearch} = $refcirc->{clasecapa}->[0];
  comfin('find traducirxml', 0,$refcirc->{clasearch});
  return 0,$refcirc->{clasearch};
} #traducirxml
# ----------------------------------------------------------------------------
sub completar_traduccion_capas{
  # para 'circuito' y 'modelo' 
  # se llega con la seguridad de tener todos los pcs y modelos definidos
  #lo que retorna completar_traduccion_capas solo  de interes para principales
  my ($archivo, $reffalta_modelo, $reffalta_pcs) = @_;
  #impr_debug(__LINE__.' Desd  $reffalta_modelo',  Dumper $reffalta_modelo);
  comfin('comd completar_traduccion_capas', @_); 
  my $refcirc = $reffi{$archivo};
  my $codcirc = $refcirc->{clasearch};
  #impr_debug(__LINE__.' Desd completar_traduccion_capas $archivo $codcirc'
  #         ,[$archivo,$codcirc]);
  ($CORTOA,$PROPIOA,$CORTOASINDIA,$PROPIOASINDIA) 
        = @$refcirc{'CORTO','PROPIO','CORTOSINDIA','PROPIOSINDIA'};
  my $coderr ='';
  foreach my $ilayer (@{$refcirc->{capas}}) {
      my $reflay = $reflayer[$ilayer];
      if (defined $reflay->{lisramascrudas}) {
         # guardar_conex($reflay); #en traducir
          if ($codcirc ne 'modelo' and $codcirc ne 'elementos') {
          cambiar_ramas_enganches($reflay) if @{$reflay->{lisramaspar}};
              #adaptar_ramas_nodos($ilayer) if @{$reflay->{lisramas}};
          };
          enganchar_ele($reflay,'despues de cambiar_ramas_enganches');

      };
      #$coderr = interpretar_archivos_complementarios($ilayer,$archivo) 
      #   if defined $reflay->{refvalores}->{ARCHIVOS_COMPLEMENTARIOS};
      #    $coderr and return $coderr;
      if ($codcirc eq 'elementos') {
          $coderr = tratar_refvalores_USO_DEF($ilayer,$archivo);     
          $coderr and return $coderr;
          #next; # $ref en @layers
          if (defined $refcirc->{refvalores}->{UNIDADES}) {
              $coderr = definir_UNIDADES($refcirc); #CUARTO eles
              delete $refcirc->{refvalores}->{UNIDADES};
              $coderr and $codcirc eq 'unidades' and return $coderr;
           };
      } elsif ($codcirc eq 'modelo' or $codcirc eq 'circuito') {
          if (defined $reflay->{lisobjconectsnonodos}) {
              $coderr = deszetar_lay($reflay, $reffalta_pcs );
              return $coderr if $coderr;
          };
      };
      #si fue posible, ya habra tomado UNIDADES de explicitos uni 
      # y del principal y  de los modelos
      if (defined  $reflay->{lisramas}){
	  controlar_conex($reflay);
           enganchar_ele($reflay);
      #debe venir luego de deszetar_lay? REVISAR  
          if ($codcirc ne 'modelo' and $codcirc ne 'elementos') { 
             cambiar_ramas_enganches($reflay) if $reflay->{lisramaspar};
              enganchar_ele($reflay,'antes de cambiar_ramas_enganches');
              correr_multiples($reflay);
              enganchar_ele($reflay,'luego correr_multiples');
              puntas_similares($reflay);
              enganchar_ele($reflay,'luego puntas_similares');
         };
      };
      foreach my $cuadro (keys %{$reflay->{refvalores}}) {
          foreach my $numobj (keys %{$reflay->{refvalores}->{$cuadro}}) {
              @{$refcirc->{refvalores}->{$cuadro}->{$numobj}}
               = @{$reflay->{refvalores}->{$cuadro}->{$numobj}};
	      #impr_debug(__LINE__.' Desd'
              #     , Dumper $refcirc->{refvalores}->{$cuadro}->{$numobj});
          };
      };
  };# my $ilayer
  if ($codcirc eq 'elementos' or $codcirc eq 'modelo') {
      if (defined $refcirc->{refvalores}->{FUNCIONES}) {
          $coderr = asignaciones(['FUNCIONES'],$refcirc,0); #para elementos 
          #impr_datos(__LINE__.' Elem refvalores_USO_DEF', $refcirc);
          delete $refcirc->{refvalores}->{FUNCIONES};
          return $coderr if $coderr;
      };
      if (defined $refcirc->{refvalores}->{TABLAS} or
          defined $refcirc->{refvalores}->{TABLAS_ARCHIVOS}) {
          $coderr = rec_apl_tablas($refcirc); #en completar_traduccion_capas
          delete $refcirc->{refvalores}->{TABLAS};
          delete $refcirc->{refvalores}->{TABLAS_ARCHIVOS};
          return $coderr if $coderr;
      };
  }; 
  #impr_debug(__LINE__.' Desd $archivo $CORTOA errores'
  #      , [$archivo, $CORTOA,$refcirc->{errores}]);
  #impr_debug(__LINE__.' Desd $defimod',  $defimod);
  #impr_debug(__LINE__.' Desd  $reffalta_modelo',  Dumper $reffalta_modelo);
  $coderr = tratar_refvalores_otros($refcirc,$archivo
             ,$reffalta_modelo,$reffalta_pcs)
       if scalar keys %{$refcirc->{refvalores}}; 
  #impr_identi(__LINE__.' Desd refcirc', $refcirc);
  #impr_debug(__LINE__.' Desd refcirc->{refvalores}'
  #      , Dumper \%refcirc->{refvalores});
  comfin('find  completar_traduccion_capas',$coderr); 
  return $coderr;
} 
# completar_traduccion_capas
# ----------------------------------------------------------------------------
sub tratar_refvalores_otros{
  #impr_debug(__LINE__.' Desd $defimod', $defimod);
  comfin('comd tratar_refvalores_otros',@_);
  my ($refcirc,$CORTO,$reffalta_modelo,$reffalta_pcs) = @_;
  #impr_debug(__LINE__.' Desd  $reffalta_modelo',  Dumper $reffalta_modelo);
  my $coderr = ''; my $clasearch = $refcirc->{clasearch};

  my $refv = $refcirc->{refvalores};
  $refcirc->{nombrecirc} = $CORTO;
#  if (defined $refv->{DEFINICION} and not defined $refv->{USO}) {
#      $refcirc->{clasearch} = 'modelo';
#      porparar1(96,0,"Falta un cuadro USO", $CORTO);
#      return 96; 
#  } elsif (defined $refv->{USO} and not defined $refv->{DEFINICION}) {
#      $refcirc->{clasearch} = 'modelo';
#      porparar1(95,0,"Falta un cuadro DEFINICION",$CORTO);
#      return 95; 
#  } elsif (defined $refv->{USO}) {
  if ($clasearch eq 'modelo') {
      my ($pcs,$nombremod);  
      $refcirc->{clasearch} = 'modelo';
      impr_debug(__LINE__.' Desd $refv',Dumper $refv);
      my @lisque = reverse sort keys %$refv;
      @lisque = grep(do {uc($_) ne 'COMENTARIOS'},@lisque); 
      impr_debug(__LINE__.' Desd @lisque',Dumper \@lisque);
      $coderr = asignaciones(\@lisque,$refcirc,1); #modelo
      not $coderr and $coderr = controlar_cadena_param($refcirc); #para mod.
      $coderr and 
      do {porparar1($coderr,$refcirc); return $coderr};
      not $coderr and  ($coderr , $pcs, $nombremod) 
              = asignar_mod($refcirc);#antes de controlar_circ 
      #impr_debug(__LINE__.' Desd  $defimod',  Dumper $defimod);
      $coderr or $coderr = controlar_circ($refcirc,'modelo'); 
      not $coderr and $coderr = controlar_modelo($refcirc);      
      if ($coderr) {
	  porparar1($coderr,$refcirc);
          #impr_debug(__LINE__.' Desd', Dumper $defimod);
          defined $defimod and defined $pcs and defined $nombremod 
          and defined $defimod->{$pcs} and 
          do {defined $defimod ->{$pcs}->{$nombremod}
              and  delete $defimod->{$pcs}->{$nombremod};
	      scalar keys %{$defimod->{$pcs}} and delete $defimod->{$pcs};
          };
          return $coderr; 
      } else {
          delete $reffalta_modelo->{$pcs}->{$nombremod};
          scalar keys %{$reffalta_modelo->{$pcs}} 
              or delete $reffalta_modelo->{$pcs};
           
      };
      #impr_datos(__LINE__. ' Desd luego controlar_modelo'
      #           ,['DATOS','PARAMETROS'], $refcirc);
      #impr_debug(__LINE__.' Desd $defimod', $defimod);

      if ($PRINCIPAL eq $CORTO) { 
	  #          imprs_archivo_mod($refcirc);
	  my $CORTOSIN = $CORTO; $CORTOSIN =~ s/\.dia$//;
	  impr_debug(__LINE__.' Desd $CORTOSIN',$CORTOSIN);
         imprs_lis_obj_sceptre($refcirc,'modelo',$CORTOSIN,$CORTOSIN); 
         parar1(1,$refcirc);
      } else {
          my @palabras = keys %{$palabrasequivV};
          #impr_debug(__LINE__.' Ampl @palabras}', \@palabras);
          marcar_nodos($refcirc,\@palabras);
      };
  } elsif ( defined $refv->{DATOS} or
	    defined $refv->{PARAMETROS}) {
      #push @{$lay_circ_arch{$CORTO}},$ilayer;
      $refcirc->{clasearch} = 'circuito';  
  } elsif (defined $refv->{GRAFICOS}) {
      $refcirc->{clasearch} = 'grafico' if $refcirc->{clasearch} eq 'dibujo';
      #puede haber varias capas; (pero para modelos todo en la misma)
  } else {
  };# if elsif elsif else defined ....USO   
  $clasearchivos{$CORTO} = $refcirc->{clasearch};
  comfin('find tratar_refvalores_otros', "clase $refcirc->{clasearch}");
  return $coderr;
}#tratar_refvalores_otros 
# ----------------------------------------------------------------------------
sub tratar_cod{
  #comfin('comd tratar_cod', @_);
  my ($reflay,$rr,$ij,$descrig,$CORTO) = @_;
  my $refcirc = $reflay->{refcirc};
  #impr_debug(__LINE__.' Desd $refcirc $reflay', [$refcirc,$reflay]);
  my $cod = $codlista->[$ij];
  my $texto = $textolista->[$ij];
  if  ($cod !~ /$codigno/) {
      push @{$reflay->{cualobjnoigno}->{$cod.$texto}}, $ij;
      push @{$refcirc->{cualobjnoigno}->{$cod.$texto}}, $ij;
      #{cualobjnoigno} se usa para asegurar que 
      # no se eligen nombres repetidos
  };
  if ($cod=~/$codconectsnonodos/) {
      push @{$reflay->{lisobjconectsnonodos}},$ij;
      push @{$refcirc->{lisobjconectsnonodos}},$ij;
  };# if ..$codconectsnonodos
  my $coderr = ''; 
  # algunos de los siguientes son if independientes
  if ($cod  =~ /$codconattrib/) {
      push @{$reflay->{cualobjcuadro}->{$cod.$texto}}, $ij;
      push @{$refcirc->{cualobjcuadro}->{$cod.$texto}}, $ij;
      $coderr = tratar_codconattrib($reflay, $rr, $ij, $texto);
      return $coderr;
  } elsif ($cod  =~ /$codcontexto/ and $cod =~ /[Nn]/) {
 
      $texto or  
     do{porparar1(80,$reflay,"Nodo sin identificación en $lugarlista->[$ij]");
      return 80;
      };
      push @{$reflay->{cualobjtextonodo}->{$texto}},$ij;
      push @{$refcirc->{cualobjtextonodo}->{$texto}},$ij;
      push @{$reflay->{lisobjnodos}},$ij;
      push @{$refcirc->{lisobjnodos}},$ij;
      return 0;
  } elsif ($cod=~/$codconhandles/) {
      push @{$reflay->{lisramascrudas}},$ij;
      $texto = $ij;      
      my $j=selec("dia:attribute","name",$nombrepuntos{$descrig},$rr);
      map (push(@{$reflay->{lugpuntos}->{$ij}},@{$_})
          ,selectags("dia:point",$rr->[$j+1]));
      $j=selec0("dia:connections",$rr); 
      if ($j){  #tiene enganches   
          map (push(@{$reflay->{conexiones}->{$ij}},@{$_})
              ,selectags('dia:connection',$rr->[$j+1]));          
      } else {
	  $reflay->{conexiones}->{$ij}= [];
      };# if else $j
  #} elsif ($cod =~ /$codcontexto/) {
  #   $cod =~ /$codconects/ and
  #   do {$nombresusados{"$cod$texto"} = 1;
  #   }	 
      return 0;
  } elsif ($cod =~ /$codigno/) {
  } elsif ($cod eq 'Z'){# en otros if si pasa algo 
  } elsif ($cod  =~ /[JECRL]/) {
      push @{$reflay->{cualobjele}->{$cod .$texto}}, $ij;
      push @{$refcirc->{cualobjele}->{$cod .$texto}}, $ij;
  } elsif ($cod eq 'T') {
     push @{$reflay->{cualobjmod}->{$cod . $texto}},$ij;
     push @{$refcirc->{cualobjmod}->{$cod .$texto}},$ij;
  };# if elsif elsif elsif ..$codnodos

    
  #{cualobjnoigno} se usa para asegurar que no se eligen nombres repetidos
  #comfin('find tratar_cod');
  return 0;
}# tratar_cod
# ----------------------------------------------------------------------------
sub tratar_codconattrib{
  my ($reflay, $rr, $ij,  $texto) = @_;
  my $refcirc = $reflay->{refcirc};
  my %pretabla;
  $texto =~ s/[\s\-]/_/g; $texto =~ s/__/_/g;
  my $crudo = string('attrib',$rr);
  my @crudo = depurar_crudo($crudo);
  $crudo = join "\n", @crudo;
  if (defined $locale{$texto}) {
      $locale{$texto} eq 'UNIDADES' and 
          $refcirc->{refvalores}->{UNIDADES}->{"\#numobj$ij"} = \@crudo  
      or $reflay->{refvalores}->{$locale{$texto}}->{"\#numobj$ij"} = \@crudo;
  };
  $CAJAS->{$refcirc->{CORTO}}  .= ' ' x 30 . " Cuadro   $texto\n" . "$crudo\n";
  if ($texto =~ /TABLA._ARCHIVO/ or $texto =~ /^ARCHIVO/) {
      #alcanza con lo ya hecho
  } elsif ($texto =~ /^\s*TABL[AE][\s_\-]*(.*)$/i) {
      my $idtabla = uc($1);
      $idtabla or
      do {porparar1(140,$reflay,"Falta identificación para la tabla");
          return 140;  
      }; 
      defined $refcirc->{objTABLA}->{$idtabla} and
      do {porparar1(141, $refcirc,"Nueva definición para tabla:
                     TABLA $idtabla");
	  return 141;
      };# do 
      $refcirc->{objTABLA}->{$idtabla} =  $ij;		      
      $reflay->{refvalores}->{TABLAS}->{$idtabla} = \@crudo;
      $pretabla{$ij} = 1;
  };# if elsif $texto   TABL
  if ($pretabla{$ij}) {
  } elsif ($texto eq '') {
      push @{$reflay->{lisobjcuadrosnoid}}, $ij
  } elsif (not defined $locale{$texto}) { 
      push @{$reflay->{lisobjcuadrosdesc}},$ij;
  } elsif ( $locale{$texto} eq 'COMENTARIOS') {  
  } else { 
      $refcirc->{hashCUADROS}->{$locale{$texto}} = 1;
  };
  return '';
} #tratar_codconattrib
# ---------------------------------------------------------------------------
sub deszetar_lay{
  comfin('comd deszetar_lay', @_);
  #hace lo que puede por traducir; no interrumpe por errores
  my ($reflay,$reffalta_pcs) =@_;
  my $refcirc = $reflay->{refcirc};
  ($CORTOA,$PROPIOA,$CORTOASINDIA,$PROPIOASINDIA) 
        = @$refcirc{'CORTO','PROPIO','CORTOSINDIA','PROPIOSINDIA'};
  my $listaobj = $reflay->{lisobjconectsnonodos};
  my @sindefinicion;
  my @conz = grep ($codlista->[$_] eq 'Z', @$listaobj);
  #impr_debug(__LINE__.' Desd @conz', \@conz);
  #impr_debug(__LINE__.' Desd reflay unionesobj'
  #   , Dumper $reflay->{unionesobj});
  foreach my $obj (@conz) {
      my $idenv = $codlista->[$obj] . $textolista->[$obj];
      my ($plantilla,$shape) 
          = ($plantillalista->[$obj], $shapelista->[$obj]);
      my $pcs = $plantilla. 'c' . $shapelista->[$obj]; 
      my $type = 
         "$nombreplantilla->[$plantilla] - $nombreshape->[$shape]"; 
      if (defined $comocod->{$pcs} and defined $comocodvalor->{$pcs}) {     
          ($codlista->[$obj],$codvalorlista->[$obj]) = 
             ($comocod->{$pcs}, $comocodvalor->{$pcs});
          my $iden = $codlista->[$obj] . $textolista->[$obj];
          #impr_debug(__LINE__.' Desd $idenv $iden', [$idenv,$iden]);
          $nombresusados{$iden} = 1;
          if ($textolista->[$obj] eq '&') {  
              $textolista->[$obj] = '0';
          } else  {
              if ($textolista->[$obj] eq '') {
                  porparar1(40,$reflay, "Elemento sin identificar:\n      "
                      . descripcion_objeto($obj));
                  return 40;
	      };# if 
	      push @{$refcirc->{cualobjele}->{$iden}},$obj;
	      push @{$reflay->{cualobjele}->{$iden}},$obj;
          }; 
          delete $reflay->{uniones}->{$idenv};
          if ($codlista->[$obj] ne 't') {             
              delete $reflay->{uni}->{$idenv};
              $reflay->{uniones}->{$iden} = $reflay->{unionesobj}->{$obj};
              $reflay->{uni}->{$iden} = $reflay->{uniobj}->{$obj};
	  } else {
              $reflay->{uniones}->{$iden} = [];
              $reflay->{uni}->{$iden} = '';
          };
          $refcirc->{uniones}->{$iden} = $reflay->{uniones}->{$iden};
          $refcirc->{uni}->{$iden} = $reflay->{uni}->{$iden};
          delete $reffalta_pcs->{$pcs};
          my $nombre = $comonombre->{$pcs};
          push @{$DEFIELE->{nombrespcsusados}}, $nombre;
      } else {
          push @sindefinicion, $type;
      };#if
      #impr_debug(__LINE__.' Desd refcirc uniones'
      #	    , Dumper $refcirc->{uniones});
      #impr_debug(__LINE__.' Desd reflay uniones'
      #	    , Dumper $reflay->{uniones});
  }; # foreach my $obj
  @sindefinicion and 
  do {@sindefinicion = union_conjunto(@sindefinicion); 
      avnograv("Sin definición para los íconos: \n"
               . join ("\n",@sindefinicion));
      for (@$listaobj) {# cambiamos código para ignorarlo
          #salvo que tenga conexiones
          if ($codlista->[$_] eq 'Z') {
	      my $iden = "Z$textolista->[$_]"; 
              my $conex = $reflay->{uniobj}->{$_};
              if (defined $conex) {
                  my $lugar = $lugarlista->[$_];
	          my @lisnodos = split '-', $conex;#salen más de lo esperado
                  mensaje(
		  " == CUIDADO == : No todos los íconos sirven para Simusol");
                  porparar1(41,$reflay,"El ícono, no definido, en $lugar
                        tiene conexiones a nodos del circuito"); 
                  return 41;
              } else {     
                  $codlista->[$_] = 'a';
	      };
	  };
      }; #for 
      #impr_debug(__LINE__.' Desde clase  ',  " $refcirc->{clasearch}");
  }; #do
  @conz = grep ($codlista->[$_] eq 'Z', @$listaobj);
  map  (delete $reflay->{uni}->{'Z' . $textolista->{$_}}, @conz);
  my $refcapa = [$reflay->{capa}];
  comfin('find deszetar_lay');
  return '';
}
# ----------------------------------------------------------------------------
sub guardar_conex{
  comfin('comd guardar_conex', @_);
  my $reflay = $_[0]; my $refcirc = $reflay->{refcirc};
  # clasifica las ramas y completa, ajustando los values para 'to'
  # a partir de $reflay->{lisobjramascrudas}
  # llena varios $reflay->{lisramas...}
  # y tambien $reflay->{hashobjcone} y $reflay->{hashtodosobjcone}
  #  key informa del to, connection y lugar
  #  y el value del par,handle donde aparecen
  my $codinteres = '[CEJLRTZl]';
  $reflay->{lisramas} = [];
  $reflay->{lisramassueltas} = [];
  $reflay->{lisramasuna} = [];
  $reflay->{lisramasauxiliares} = [];
  $reflay->{lisramaspoly} = [];
  $reflay->{lisramaspar} = [];
  $reflay->{lisramasinut}= [];
  $reflay->{lisramasquerepiten} = [];
  my $conver_obj = $refcirc->{conversion};
  my $hash = $reflay->{conectados_por_ramas}; #1a key es rama; 
  # 2a key terna to-cod-lugar value 1
  foreach my $rama (sort @{$reflay->{lisramascrudas} } ) {
      my $cuantasconaux= 0;
      my $listacon = $reflay->{conexiones}->{$rama};
      my $listalug = $reflay->{lugpuntos}->{$rama};
      map ($_ = mejorar_lugar($_), @$listalug);
      my $cuantasconauxmax = @$listacon;
      if (@$listacon) {
          my @listacla; my ($cod, $to); 
          my $indice = -1;
          foreach  (@$listacon) {
              $indice ++;
              my ($to,$connection,$handle) = @$_{'to','connection','handle'};
              $to =~ s/^.//;
              $to = $conver_obj->{$to};
              $cod = $codlista->[$to];
              if ($cod =~ /[AO]/) {
                  delete $reflay->{conexiones}->{$rama}->[$indice];
                  $cuantasconaux ++; 
                  next;
              };
              my $codrama = $codlista->[$rama];
              my $lug = $listalug->[$handle];
              if ($codrama eq 'X') { 
                   $handle == 1 and  # 'ZigZag'
                   $lug = $listalug->[-1];
              };
              $_->{cod} = $cod; $_->{lugar} = $lug;
              $_->{to} = $to; $_->{rama} = $rama; 
              if ($rama == $to) {
                  avnograv("Conexion inútil de rama consigo misma, se ignora
                  en $lug; archivo $refcirc->{archivo}, capa $reflay->{capa}");
                   $_->{to} = 0;
                   next;
              };
              if ($cod eq  'l') {
                    push@{$reflay->{lisramaspar}},[$rama,$to];
              }; 
              my $terna = $to.'-'.$connection.'-'. $lug;
              if ($reflay->{ramaterna}->{$rama}->{$terna}) {
                  avnograv("Conexión repetida de una rama en $lug;
                         se ignora");
                  $_->{to} = 0;
                  next;
	      };
              $reflay->{ramaterna}->{$rama}->{$terna} = 1;
              push @listacla, $terna;
              push @{$reflay->{hashobjcone}->
                    {$to.'-'.$connection}}, 
                    [$rama,$handle]   if  $cod =~ /$codinteres/;         
              push @{$reflay->{hashtodosobjcone}->
                    {$to.'-'.$connection }}, 
                 [$rama,$handle];         
          }; # foreach @listacon
          @$listacon = grep(defined $_,@$listacon);
          my $tira = join '=',sort @listacla;
          if (defined $hash->{$tira}) { 
              push @{$reflay->{lisramasquerepiten}}, $rama;
	      next;
          } elsif ($tira) { 
              $hash->{$tira} = $rama;
          };
          #impr_enganches(__LINE__." Desd ", $rama);
          if ($cuantasconaux == $cuantasconauxmax) {
              push @{$reflay->{lisramasauxiliares}}, $rama;
          } elsif (@listacla == 0) {
              push @{$reflay->{lisramassueltas}}, $rama;
          } elsif (@listacla == 1) {
              push @{$reflay->{lisramasuna}}, $rama;
          } elsif (@listacla == 2) {
              push  @{$reflay->{lisramas}}, $rama;
          } elsif (@listacla > 2) {
              push  @{$reflay->{lisramaspoly}}, $rama;
          };
      } else {
          push @{$reflay->{lisramassueltas}}, $rama;
      }
  }; #foreach my rama
  #impr_ramas(__LINE__.' Desd guardar_conex ',$reflay);
  if (@{$reflay->{lisramaspoly}}) {
      eliminar_ramas_poly($reflay);
      #impr_ramas(__LINE__.' Desd guardar_conex ',$reflay); 
  };
  comfin('find guardar_conex');
  return '';
}
# -----------------------------------------------------------------------------
sub puntas_similares{
  comfin('comd puntas_similares', @_);
  my $reflay = $_[0];
  my @ramasya = @{$reflay->{lisramas}}; #estas ramas tienen exactamente 2 eng.
  # no hay que revisar las que se agreguen aqui
 foreach my $rama ( @ramasya){ 
      my $refenganche0 = $reflay->{conexiones}->{$rama}->[0];
      my $refenganche1 = $reflay->{conexiones}->{$rama}->[1];
      my ($cone0,$to0,$lug0,$handle0) =  
                @$refenganche0{'connection','to','lugar','handle'};
      my ($cone1,$to1,$lug1,$handle1) =
                @$refenganche1{'connection','to','lugar','handle'};
      next if $to0 == 0 or $to1 == 0;
      if ($to0 == $to1 and $cone0 == $cone1) {
          push @{$reflay->{lisramasinut}},$rama;
      } else {
          my $cod0 = $codlista->[$to0];
          my $cod1 = $codlista->[$to1]; 
          my $tipos = "$cod0$cod1";
          my ($texto0, $texto1) = @$textolista[$to0,$to1]; 
          my $texto0s = $reflay->{sustituir_nodo}->{$texto0};
          defined $texto0s and $texto0 = $texto0s;
          my $texto1s = $reflay->{sustituir_nodo}->{$texto1};
          defined $texto1s and $texto1 = $texto1s;
          my $cuantosnodosps=($tipos=~tr/nNt//);
          if ($cuantosnodosps==2) {
              if ($texto0 eq $texto1) {
	          avnograv("No es necesario conectar nodos de igual nombre: " .
                           $texto0);
              } elsif (defined $reflay->{hashnodoscreados}->{$texto0}) {
                  $reflay->{sustituir_nodo}->{$texto0} = $texto1;
                  delete $reflay->{hashnodoscreados}->{$texto0}; 
              } elsif (defined $reflay->{hashnodoscreados}->{$texto1}) {
                  $reflay->{sustituir_nodo}->{$texto1} = $texto0;
		  delete $reflay->{hashnodoscreados}->{$texto1};
              } else {
         	  # debe interpretarse la rama como una resistencia nula:
                  # de plantila y shape ficticias ('')
	          # agregamos en uno de sus extremos  
	          # una resistencia nula y otra rama 
	          #my $ramaant=$rama; my $nodopost = $to1;
	          my ($ijR,$codR,$textoR) 
                    = crear_objeto($laylista->[$rama],'R','','',$lug0,
                                   'R','0');
                  $refenganche0->{connection} = 1;
                  $refenganche0->{to} = $ijR;
                  #impr_debug(  __LINE__," Desd,  $ijR", 
                  #           "$codlista->[$ijR], $textoR"); 
                  avnograv("En lugar de conectar dos nodos con una rama, 
         puede utilizar un  nodo duplicado con igual texto identificatorio.
             Nodos conectados: $textolista->[$to0] - $textolista->[$to1] 
             Lugares de conexión:  $lug0,  $lug1
         Hemos incorporado un resistencia nula R$textoR entre esos nodos"); 
#                  my $refDATOS = $reflay->{refcirc}->{refvalores}->{DATOS};
#                  if (not defined $refDATOS) {
#                      parar1(66,$reflay,'Necesita un cuadro DATOS')
#                  };
#	          my $key = (keys %$refDATOS)[0];
#                  push  @{$reflay->{refcirc}->{refvalores}->{DATOS}->{$key}},
#                         "$codR$textoR = 0"; 
                  my ($ijx,$codx,$textor) = 
	          crear_objeto($laylista->[$rama],'x','','',$lug0,
		               $lug0,$lug0,$to0,$cone0,$ijR,0);
              };# if else $textolista ...
          } elsif ($cuantosnodosps == 0) {
             #no hay nodos; se crea nodo y rama 
              my ($inodo,$codn,$texton)
	        = crear_objeto($laylista->[$rama],'N','','',$lug0,'N',"");
              my ($irama,$codr,$textor) =
                crear_objeto($laylista->[$rama],'x','','',$lug0,$lug0,$lug0,
                           $inodo,2,$to1,$cone1);
              $refenganche1->{to} = $inodo; $refenganche1->{lugar} = $lug0;
              $refenganche1->{connection} = 2; $refenganche1->{cod} = 'n';
              #impr_enganches("cuantosnodos == 0 tipos $tipos",$rama);
          };# if elsif $cuantosnodos
      };# if else $codlista ....   
  };#foreach
  #impr_debug(__LINE__." Desd sustituir_nodo ", $reflay->{sustituir_nodo});
  comfin('find puntas_similares nodoscreados'
         , keys %{$reflay->{hashnodoscreados}});
  return '';
}
# ----------------------------------------------------------------------------
sub unionesobj2uni{
  #se llama desde enganchar_ele
  #comfin('comd unionesobj2uni',@_);
  my $reflay = $_[0];
  $reflay->{uniobj} = {};
  $reflay->{uni} = {};
  my @listaternas;
  foreach my $terna ($reflay->{hashtodosobjcone}) {
       push @listaternas, keys %$terna;
  };
  foreach my $obj (keys %{$reflay->{unionesobj}}) {
      next unless defined $obj;
      my $cod = $codlista->[$obj];
      my $iden = "$cod$textolista->[$obj]";
      my $reflisobj = $reflay->{unionesobj}->{$obj};  
      my $tira;
      if ($cod =~ /[Nnt]/) { next;
      } elsif ($cod eq 'T') {
          my @nodosobj;my @pares = @{$reflay->{ramaconeobjmodelos}->{$obj}};
          my $conexion = 0;
          foreach my $par (@pares) {
              if (defined $par) {
                  my ($rama,$handle) = @$par; 
                  push @nodosobj, 
                     $reflay->{conexiones}->{$rama}->[1 - $handle]->{to};
              } else {
                  push @nodosobj,'x';
              };    
          }; 
          $tira =  ordenar_nodos($obj,@nodosobj);
      } else {
          my @lisuni; 
          foreach my $noditoobj (@$reflisobj) {
             my $nodito = $textolista->[$noditoobj];  
             my $noditos = $reflay->{sustituir_nodo}->{$nodito};
             defined $noditos and $nodito = $noditos; 
	     $noditoobj  and push @lisuni, $nodito
                or push @lisuni, 0;
          };
          $tira =  join '-', @lisuni; 
      }; 
      $reflay->{uniobj}->{$obj} =  $tira;
      $reflay->{uni}->{$iden} = $tira; 
      $reflay->{refcirc}->{uni}->{$iden} = $tira;
  };
  #impr_unionesobj(__LINE__.' Desd unionesobj',$reflay);
  #impr_debug(__LINE__." Desd unionesobj2uni ", 
  #       Dumper $reflay->{refcirc}->{uni});
  #comfin('find unionesobj2uni');
  return '';
} 
# ----------------------------------------------------------------------------
sub enganchar_ele{
  comfin('comd enganchar_ele', @_);
  # llena $reflay-{unionesobj} con, para cada objeto, la lista ordenada
  # por número de conexión del objeto
  # (y si hay ramas multiples, al final no habra, por handle de esa rama), 
  # de los objetos conectados a el
  my ($reflay,$mensaje) = @_ ;
  my $refcirc = $reflay->{refcirc};
  #my ($reflista,$refcual)=interpretar_enganches($reflay);#no se usara $refcual
  my $reflista;
  my $unionesobj = $reflay->{unionesobj} = {};
  $reflay->{ramaterna} = {};
  $reflay->{hashobjcone} = {};
  $reflay->{hashtodosobjcone} = {};
  # cada enganche corresponde a un enganche de una rama; 
  # datos basicoS:
  #    numero de orden de la rama, 
  #    numero de orden del enganche de la  rama
  #    numero de objeto del enganchado 
  #    numero de conexion del enganchado
  #    cod del enganchado
  #    lugar del enganche 
   foreach my $ramaq (keys %{$reflay->{conexiones}}) {  
      next if not defined $ramaq;
      foreach my $enganche (@{$reflay->{conexiones}->{$ramaq}}) {
          my ($rama,$handle,$to,$connection,$lug) =
             @$enganche{'rama','handle','to','connection','lugar'}; 
          next if $to == 0 or $to eq '&';
          my $terna = $to.'-'.$connection.'-'. $lug;
          if ($reflay->{ramaterna}->{$rama}->{$terna}) {
               avnograv(__LINE__." conexion repetida de una  rama en $lug;
                              se ignora");
               $enganche->{to} = 0;
               next;
	  };
          $reflay->{ramaterna}->{$rama}->{$terna} = 1;
          my $cod = $codlista->[$to];
          push @{$reflay->{hashobjcone}->{$to.'-'.$connection }}, 
                    [$rama,$handle]   if  $cod =~ /[CEJLRTZ]/;
          # aqui ya no quedaron 'l'         
          push @{$reflay->{hashtodosobjcone}->
                    {$to.'-'.$connection }}, 
                 [$rama,$handle];         
          $reflay->{ramaconeobjmodelos}->{$to}->[$connection] = 
	      [$rama,$handle] if $cod eq 'T';
     };
  };
  my @lisobjcone = keys %{$reflay->{hashtodosobjcone}};
  my @listanonodos;
  foreach my $obj (@{$reflay->{lisobjtodos}}) {
      my @lista = grep (/^$obj\-/,@lisobjcone);
      @listanonodos = grep ($codlista->[$obj] !~ /[Nnt]/,@lista);
      foreach my $terna (sort @lista) {# es fundamental este orden
          my ($cone,$lug) = ($terna =~ /^$obj\-(.+)\-(.+)$/);
          my @listita = @{$reflay->{hashtodosobjcone}->{$terna}};
          foreach (@listita) {
              my ($rama,$handle) = @$_;
              foreach my $hash (@{$reflay->{conexiones}->{$rama}}) {
                  my ($hand, $to,$coneto) = 
                  @$hash{'handle', 'to','connection'};
                  $hand == $handle and next;
                  $to == 0 and next;
                  push @{$reflay->{unionesobj}->{$obj}}, $to ;
                  next if $codlista->[$obj] =~ /[Nnt]/; 
               };
          };
      };
  };
  unionesobj2uni($reflay);
  #impr_obj(__LINE__.' Desd ','[RZNntE]',[0]);
  #comfin('find enganchar_ele');
  #impr_debug(__LINE__.' Desd unionesobj', Dumper $reflay->{unionesobj});
  return'';
}
# ----------------------------------------------------------------------------
sub ordenar_nodos{
   my ($obj,@listanodosfull) = @_;
   my @listanodosord=();my %hash; my @otro_orden;
   my $shapeobj = $nombreshape->[$shapelista->[$obj]];   #if ($shapeobj eq 'modelo') {
       for (my $i = 0; $i < @orden_nodos_mod; $i ++) {
           my $bueno = $orden_nodos_mod[$i];
           my $objnodo =  $listanodosfull[$bueno];
           defined $objnodo and push @listanodosord, $objnodo or
           push @listanodosord, 'x';  
       };
   #} else {
   #    @listanodosord = @listanodosfull
   #};
   @listanodosord = grep($_ ne 'x', @listanodosord);
   map ($_ = $textolista->[$_],@listanodosord); 
   my $unibue = join ('-',@listanodosord); 
   return $unibue; 
}#ordenar_nodos
# ----------------------------------------------------------------------------
sub cambiar_ramas_enganches{
  # trata de ramas enganchadas a puntos de conexion de lineas
  # a partir de $reflay->{lisramaspar}, llenada por guardar_conex,
  # y $reflay->{conexiones}
  # lleva esas conexiones hasta un punto equivalente
  my ($reflay)=@_; 
  comfin ("com cambiar_ramas_enganches, @_");
  foreach my $par (@{$reflay->{lisramaspar}}) {
     my ($ramallega,$ramaesta) = @$par;
      #impr_enganches(__LINE__." Desd llega antes $ramallega",$ramallega);
      #impr_enganches(__LINE__." Desd esta $ramaesta",$ramaesta);
      my $refconex = $reflay->{conexiones}->{$ramallega};
      my $conex0 = $reflay->{conexiones}->{$ramaesta}->[0];
      if (defined $conex0) {
          my ($to,$connection,$cod,$lug) = 
               @$conex0{'to','connection','cod','lugar'};
          $to== 0  and next;
          foreach (@$refconex) {
              next unless $_->{to}  eq $ramaesta;
              my $handle = $_->{handle};
              $_->{to} = $to; $_->{cod} = $cod;$_->{lugar} = $lug;
              $_->{connection} = $connection,
              #impr_enganches('llega despues',$ramallega);
              push @{$reflay->{hashobjcone}->{"$to-$connection"}},
                         [$ramallega,$handle]; 
              push @{$reflay->{hashtodosobjcone}->{"$to-$connection"}},
                         [$ramallega,$handle]; 
          };
      } else {
          avnograv ("Completar")   
      };
      $reflay->{lisramaspar} = [];
  };
  comfin('find cambiar_ramas_enganches');
  return '';
} # cambiar_ramas_enganches
# ----------------------------------------------------------------------------
sub correr_multiples{  
  comfin ('com correr_multiples', @_);
  my ($reflay)=@_; 
  my $hashobjcone = $reflay->{hashobjcone};
  #impr_debug(__LINE__.' Desd hashobjcone', Dumper $reflay->{hashobjcone}); 
  foreach my $key (sort keys %$hashobjcone) {
      #impr_debug(__LINE__ ." Desd ", "ramas múltiples desde $key"); 
      my $lisramahandle = $hashobjcone->{$key};
      next if @$lisramahandle == 1; 
      my ($nodoobj, $cone, $lug);
      my $bien =''; my $i0;
      for (my $i = 0; $i < @$lisramahandle; $i ++) { 
          my ($ramaq,$handleq) = @{$lisramahandle->[$i]};
          # aqui $handle solo vale 0 o 1;
          my $otrohandle = 1-$handleq; 
	  #impr_enganches('',$ramaq);
          ($nodoobj,$lug) = 
	      @{$reflay->{conexiones}->{$ramaq}->[$otrohandle]}{'to','lugar'};
          $codlista->[$nodoobj] =~ /[Nnt]/ and do {$bien = 1; $i0 = $i; last};
     };
      if (not $bien) {           
          my ($obj,$cone)  =  ($key =~/^(\d+)\-(.+)$/);
          ($nodoobj,my $codn,my $texton) =
             crear_objeto($laylista->[$obj],'N','','','','N',''); 
          my ($ramaobj,$codr,$textor) =
                crear_objeto($laylista->[$obj],'x','','','','',
                     '', $obj,$cone,$nodoobj, 2); 
          #impr_enganches ("rama nueva", $ramaobj);
          $i0 =  @$lisramahandle +1; 
      };
      for (my $i = 0; $i <@$lisramahandle; $i ++) {
          next if $i == $i0;
          my ($rama,$handle) =  @{$lisramahandle->[$i]}; 
          foreach (@{$reflay->{conexiones}->{$rama}} ) {
              next unless $_->{handle} eq $handle;
              #impr_enganches("antes correr_multiple",$rama);
              $_->{to} = $nodoobj;
              $_->{connection} = 2; $_->{cod} = 'n';
              #impr_enganches("despues correr_multiple",$rama);
          }; 
      };
  };
  comfin('find correr_multiples');
  return '';
} #
# ----------------------------------------------------------------------------
sub desagrupar{
  comfin('comd desagrupar');
#se da la referencia a la lista arbolada y cada grupo que contenga, se
# sustituye por su lista de agrupados
  my $ref=$_[0];
  #imprlisarb("lisantes",$ref);
  my $indice=selec0("dia:group",$ref); 
  while ($indice>0) {
     my @lisobj=@{$ref->[$indice+1]};
     splice(@lisobj,0,3);
     splice(@{$ref},$indice,2,@lisobj);
     $indice=selec0("dia:group",$ref);
  }
  #imprlisarb("lisdespues",$ref);
  comfin('find desagrupar');
  return '';
 }
# ----------------------------------------------------------------------------
sub string{
  # en una lista arbolada dada por su refencia,
  # busca el string correspodiente  a un "dia:attribute"
  # con valor para  "name" dado 
  my ($valor,$ref)=@_;
  my @lista=@$ref;
  my $texto='&';
  my $j=selec("dia:attribute", "name",$valor,$ref);
  $j or return $texto;
  my $jj=selec("dia:composite","type","text",${$ref}[$j+1]);
  $jj or return $texto;
  my $jjj=selec("dia:attribute","name","string",${$ref}[$j+1][$jj+1]);
  $jjj or return $texto;
  my $jjjj=selec0("dia:string",${$ref}[$j+1][$jj+1][$jjj+1]);
  $jjjj or return $texto;    
  $texto=${$ref}[$j+1][$jj+1][$jjj+1][$jjjj+1][2];
  $texto=~s/^\#\s*([.]*)/$1/;  
  $texto=~s/([.]*)\s*\#$/$1/;  
      # si se usa una sola sentencia para limpiar a ambos 
      # lados, los de más de un renglon no se limpian 
            #  el . no representa un fin de línea
  return $texto;
}
# ----------------------------------------------------------------------------
sub selec{
   # en una lista arbolada dada por su referencia, $ref
   # busca el índice (y lo retorna o retorna 0 si no)
   # para el comienzo del primer nodo basico
   # con tag igual  $tagbuscada, y con key $conkey y valor $valorkey
   my ($tagbuscada,$conkey,$valorkey,$ref)=@_;
   #print $ref,"\n";
   my @lista=@$ref;  
   for (my $ii=1; $ii<@lista -1; $ii += 2) {
      #podria empezarse con $i=3 y aumentar de 4, si seguro prettyprint?
        $lista[$ii] eq $tagbuscada
     &&	 $lista[$ii+1][0]{$conkey} eq  $valorkey
     && do {
          return $ii}
   };
   return 0 
}
# ----------------------------------------------------------------------------
sub selec0{
   # en una lista arbolada dada por su referencia,
   # busca el índice (y lo retorna o retorna 0 si no)
   # para el comienzo del primer nodo basico
   # con tag igual al tag buscado
   my ($tagbuscada,$ref)=@_;
   my @lista=@$ref;
   #impr_debug( __LINE__.' Desd la lista',$ref);  
   for (my $ii=1; $ii<@lista -1; $ii += 2){
       #podria empezarse con $i=3 y aumentar de 4
       #si estuvieramos seguros del pretty print
        $lista[$ii] eq $tagbuscada
     && do {
            return $ii}
   };
   return 0 
}
# ----------------------------------------------------------------------------
sub selectags{
  # en una lista de arboladas, dada por su referencia, y en su primer nivel,
  # busca los elementos con un tag igual al buscado;
  # devuelve una lista, por sí,
  # con las referencias a las listas arboladas correspondientes.
  my ($tagbuscado, $refla)=@_;
  my @lisarb=@$refla;
  my $hash=shift @lisarb;
  my @lista=();
   while (my @ele=splice (@lisarb,0,2)){
      push (@lista, $ele[1]) if $tagbuscado eq $ele[0];      
  };
  my $encontrados=@lista;
  return @lista
}
# ----------------------------------------------------------------------------
sub mejorar_lugar{
  #recibe referencia a hash con key 'val'....
  #lo que sigue simplfica, corta decimales de la coordenadas de un string 
  #lugares
  my $lug=pack("A16",sprintf ("(%.1f, %.1f)",split(/,/,$_[0]->{val})));
  return $lug 
}
# ----------------------------------------------------------------------------
sub crearfantasma{
  my $objfantasma = scalar @$codlista;
  push @$lugarlista,'(?,?)';
  push @$codlista,'?';
  push @$codvalorlista,'?';
  push @$textolista,$_[0];
  push @$laylista,$_[0];
  push @$plantillalista,$cualplantilla->{'fantasmaplan'};
  push @$shapelista,$cualshape->{'fantasmashape'};
  $reflayer[$_[0]]->{cualobjconects}->{"?$_[0]"} = [$objfantasma];
  push @{$reflayer[$_[0]]->{lisobjtodos}},$objfantasma;
  $comonombre->{$plantillalista->[-1] . 'c' . $shapelista->[-1]} 
      = 'obj_fantasma';
}
# ----------------------------------------------------------------------------
sub eliminar_ramas_poly{
 #terminara sin ramas poly; las otras pueden aumentar 
  comfin('comd eliminar_ramas_poly',@_);
  my $reflay = $_[0]; 
  foreach my $rama (@{$reflay->{lisramaspoly}}) {
      #impr_debug(__LINE__.' Desd unidos'
      #    ,Dumper $reflay->{conexiones}->{$rama});
     my @todosobj = @{$reflay->{conexiones}->{$rama}};
     my @objetosZT; my @nodos; my @tierras; my @ignorables;
     foreach my $conexion (@todosobj) {
         my $unido = $conexion->{to}; my $cod = $codlista->[$unido];
         $cod =~ /[ZT]/  and  push @objetosZT, $unido or
         $cod =~ /[Nn]/ and push @nodos, $unido or
         $cod eq 't' and push @tierras, $unido or 
         push @ignorables, $unido 
     };
     push @{$reflay->{lisramasinut}}, $rama;
     if (@ignorables == @todosobj or @ignorables +1 == @todosobj) {next};
     my $nodoesp; my @aconectar;
     if (@tierras) {
         $nodoesp = shift @tierras;
     } elsif (@nodos) {
         $nodoesp = shift @nodos; 
     } else {
       my ($ij, $codnodo, my $texto) = 
        crear_objeto($laylista->[$rama],'N','','','','N',''); 
       $nodoesp = $ij;
     };
     foreach my $conexion (@todosobj) {
         my ($obj,$cone) = @$conexion{'to','connection'};
         next if $obj eq $nodoesp;
         my ($ij, $codnodo, my $texto) = 
	    crear_objeto($laylista->[$rama],'x','','','','',''
                    ,$nodoesp,2,$obj,$cone);
     #impr_enganches(__LINE__.' Desd ',$ij);
     };
     delete $reflay->{conexiones}->{$rama};
  };
  $reflay->{lisramaspoly} = [];
  comfin('find eliminar_ramas_poly',@_);
}#eliminar_ramas_poly
# ----------------------------------------------------------------------------
1
